#!/usr/bin/env groovy

pipeline {
    agent any
    //tools {
    //    Maven 'maven'
    //}
   /* agent {
        docker {
            image 'node:lts-bullseye-slim' 
            args '-p 3000:3000' 
        }
    } */
    environment {
        IMAGE_REPO = 'famaten/my-repo'
        IMAGE_NAME = 'my-nodejs-app-monitoring-v1.0'
    }
    stages {
        stage("build app") {
            steps {
                script {
                    echo "building application..."
                    sh 'npm install'
                }
            }
        }
        stage("build image") {
            steps {
                script {
                    echo "building image and pushing into docker registry..."
                    withCredentials([usernamePassword(credentialsId: 'docker-hub-repo', passwordVariable: 'PASS', usernameVariable: 'USER')]) {
                        sh "docker build -t ${IMAGE_REPO}:${IMAGE_NAME} ."
                        sh "echo $PASS | docker login -u $USER --password-stdin"
                        sh "docker push ${IMAGE_REPO}:${IMAGE_NAME}"
                    }
                }
            }
        }
/*
        stage("deploy") {
            steps {
                script {
                    echo "no deployment this time (: "
                    //echo "deploying to EC2 AWS Cloud..."
                    //def dockerRunCmd="docker run -d -p 8080:8080 famaten/my-repo:${IMAGE_NAME}"
                    //sshagent(['ec2-server-key']) {
                    //    sh "ssh -o StrictHostKeyChecking=no ec2-user@44.202.82.233 ${dockerRunCmd}"
                    //}
                }
            }
        }
*/
    }
}